/*
 * Part of the ROBOID project - http://hamster.school
 * Copyright (C) 2016 Kwang-Hyun Park (akaii@kw.ac.kr)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA  02111-1307  USA
*/

#include <windows.h>
#include "library.h"

HINSTANCE _roboid_hinstance;

void roboid_load_library(void) {
	_roboid_hinstance = LoadLibrary("roboid.dll");

	HMODULE hmodule = (HMODULE)_roboid_hinstance;
	if(hmodule == NULL) return;

	scan = (_SCAN)GetProcAddress(hmodule, "scan");
	set_executable = (_SET_EXECUTABLE)GetProcAddress(hmodule, "set_executable");
	wait = (_WAIT)GetProcAddress(hmodule, "wait");
	wait_until = (_WAIT_UNTIL)GetProcAddress(hmodule, "wait_until");
	wait_until_ready = (_WAIT_UNTIL_READY)GetProcAddress(hmodule, "wait_until_ready");
	dispose_all = (_DISPOSE_ALL)GetProcAddress(hmodule, "dispose_all");
	
	hamster_create = (_HAMSTER_CREATE)GetProcAddress(hmodule, "hamster_create");
	hamster_create_port = (_HAMSTER_CREATE_PORT)GetProcAddress(hmodule, "hamster_create_port");
	hamster_get_name = (_HAMSTER_GET_NAME)GetProcAddress(hmodule, "hamster_get_name");
	hamster_set_name = (_HAMSTER_SET_NAME)GetProcAddress(hmodule, "hamster_set_name");
	hamster_get_id = (_HAMSTER_GET_ID)GetProcAddress(hmodule, "hamster_get_id");
	hamster_e = (_HAMSTER_E)GetProcAddress(hmodule, "hamster_e");
	hamster_read = (_HAMSTER_READ)GetProcAddress(hmodule, "hamster_read");
	hamster_read_at = (_HAMSTER_READ_AT)GetProcAddress(hmodule, "hamster_read_at");
	hamster_read_array = (_HAMSTER_READ_ARRAY)GetProcAddress(hmodule, "hamster_read_array");
	hamster_read_float = (_HAMSTER_READ_FLOAT)GetProcAddress(hmodule, "hamster_read_float");
	hamster_read_float_at = (_HAMSTER_READ_FLOAT_AT)GetProcAddress(hmodule, "hamster_read_float_at");
	hamster_read_float_array = (_HAMSTER_READ_FLOAT_ARRAY)GetProcAddress(hmodule, "hamster_read_float_array");
	hamster_write = (_HAMSTER_WRITE)GetProcAddress(hmodule, "hamster_write");
	hamster_write_at = (_HAMSTER_WRITE_AT)GetProcAddress(hmodule, "hamster_write_at");
	hamster_write_array = (_HAMSTER_WRITE_ARRAY)GetProcAddress(hmodule, "hamster_write_array");
	hamster_write_float = (_HAMSTER_WRITE_FLOAT)GetProcAddress(hmodule, "hamster_write_float");
	hamster_write_float_at = (_HAMSTER_WRITE_FLOAT_AT)GetProcAddress(hmodule, "hamster_write_float_at");
	hamster_write_float_array = (_HAMSTER_WRITE_FLOAT_ARRAY)GetProcAddress(hmodule, "hamster_write_float_array");
	hamster_reset = (_HAMSTER_RESET)GetProcAddress(hmodule, "hamster_reset");
	hamster_dispose = (_HAMSTER_DISPOSE)GetProcAddress(hmodule, "hamster_dispose");
	hamster_wheels = (_HAMSTER_WHEELS)GetProcAddress(hmodule, "hamster_wheels");
	hamster_left_wheel = (_HAMSTER_LEFT_WHEEL)GetProcAddress(hmodule, "hamster_left_wheel");
	hamster_right_wheel = (_HAMSTER_RIGHT_WHEEL)GetProcAddress(hmodule, "hamster_right_wheel");
	hamster_stop = (_HAMSTER_STOP)GetProcAddress(hmodule, "hamster_stop");
	hamster_line_tracer_mode = (_HAMSTER_LINE_TRACER_MODE)GetProcAddress(hmodule, "hamster_line_tracer_mode");
	hamster_line_tracer_speed = (_HAMSTER_LINE_TRACER_SPEED)GetProcAddress(hmodule, "hamster_line_tracer_speed");
	hamster_board_forward = (_HAMSTER_BOARD_FORWARD)GetProcAddress(hmodule, "hamster_board_forward");
	hamster_board_left = (_HAMSTER_BOARD_LEFT)GetProcAddress(hmodule, "hamster_board_left");
	hamster_board_right = (_HAMSTER_BOARD_RIGHT)GetProcAddress(hmodule, "hamster_board_right");
	hamster_leds = (_HAMSTER_LEDS)GetProcAddress(hmodule, "hamster_leds");
	hamster_left_led = (_HAMSTER_LEFT_LED)GetProcAddress(hmodule, "hamster_left_led");
	hamster_right_led = (_HAMSTER_RIGHT_LED)GetProcAddress(hmodule, "hamster_right_led");
	hamster_beep = (_HAMSTER_BEEP)GetProcAddress(hmodule, "hamster_beep");
	hamster_buzzer = (_HAMSTER_BUZZER)GetProcAddress(hmodule, "hamster_buzzer");
	hamster_tempo = (_HAMSTER_TEMPO)GetProcAddress(hmodule, "hamster_tempo");
	hamster_pitch = (_HAMSTER_PITCH)GetProcAddress(hmodule, "hamster_pitch");
	hamster_note = (_HAMSTER_NOTE)GetProcAddress(hmodule, "hamster_note");
	hamster_io_mode_a = (_HAMSTER_IO_MODE_A)GetProcAddress(hmodule, "hamster_io_mode_a");
	hamster_io_mode_b = (_HAMSTER_IO_MODE_B)GetProcAddress(hmodule, "hamster_io_mode_b");
	hamster_output_a = (_HAMSTER_OUTPUT_A)GetProcAddress(hmodule, "hamster_output_a");
	hamster_output_b = (_HAMSTER_OUTPUT_B)GetProcAddress(hmodule, "hamster_output_b");
	hamster_signal_strength = (_HAMSTER_SIGNAL_STRENGTH)GetProcAddress(hmodule, "hamster_signal_strength");
	hamster_left_proximity = (_HAMSTER_LEFT_PROXIMITY)GetProcAddress(hmodule, "hamster_left_proximity");
	hamster_right_proximity = (_HAMSTER_RIGHT_PROXIMITY)GetProcAddress(hmodule, "hamster_right_proximity");
	hamster_left_floor = (_HAMSTER_LEFT_FLOOR)GetProcAddress(hmodule, "hamster_left_floor");
	hamster_right_floor = (_HAMSTER_RIGHT_FLOOR)GetProcAddress(hmodule, "hamster_right_floor");
	hamster_acceleration_x = (_HAMSTER_ACCELERATION_X)GetProcAddress(hmodule, "hamster_acceleration_x");
	hamster_acceleration_y = (_HAMSTER_ACCELERATION_Y)GetProcAddress(hmodule, "hamster_acceleration_y");
	hamster_acceleration_z = (_HAMSTER_ACCELERATION_Z)GetProcAddress(hmodule, "hamster_acceleration_z");
	hamster_light = (_HAMSTER_LIGHT)GetProcAddress(hmodule, "hamster_light");
	hamster_temperature = (_HAMSTER_TEMPERATURE)GetProcAddress(hmodule, "hamster_temperature");
	hamster_input_a = (_HAMSTER_INPUT_A)GetProcAddress(hmodule, "hamster_input_a");
	hamster_input_b = (_HAMSTER_INPUT_B)GetProcAddress(hmodule, "hamster_input_b");
}

void roboid_free_library(void) {
	FreeLibrary((HMODULE)_roboid_hinstance);
}
